// 뢮  䠩 p GIF
#include <stdio.h>
#include <malloc.h>
#include <string.h>

#include "gif.h"

char OUTFILE[256];

#pragma pack(1)

struct GIFHEADER {
  char	 GIFVer[6];	//  GIF  = "GIF89a"
  ushort Width;		// p p
  ushort Height;	//  p
  uint	 SizeGCT:3;	// p GCT...   p p ⢮
			// p 梥⮢
  uint	 Sort:1;	// SortFlag, 㪠뢠  GCT pp
			//  p浪 稬 梥⮢ (  p
			// ?)
  uint	 CRes:3;	// Color resolution
			// H 祭 ⭮  ⠪,
			// - 梥  pp p
  uint	 GCT:1;		// GlobalColorTable Flag - 뢠  쭠
			// ⠡ 梥⮢  ᫥  ⨬ 
			// (  1!)
  uchar  Backgr;	//  梥 (  GCT. 0 - p饭)
  uchar  PixAspect;	// ⠡ ⮫? H ...   㤥 !
} GIFHeader;

//   GCT.   pp  3 * 2 ^ (SizeGCT + 1);
// SizeGCT   ᮮ⢥⢥ 2 4 8 16 32 64 128 256 梥⮢
//  訬   㤥 ᮮ⢥⢥ p
//  ⠪:
//   SizeGCT = 0;
//   SizeMask = 0xfe;
//   while (Colors & SizeMask) {
//	   SizeMask <<= 1;
//	   SizeGCT++;
//   }

//  p GCT ⠪:
//  Red1 Green1 Blue1	// 3 
//  Red2 Green2 Blue2	// 3 
//  Red3 Green3 Blue3	// 3 
//  ...
//

// p 室 pp筮 p㭤  㦭 뢨 
// Graphics control extension
struct {
  char   Introducer;	// 0x21
  uchar  Label;		// 0xf9
  uchar  BSize;		// 4
  uint   CFlag:1;	// Transparent color flag
  uint   UIFlag:1;	// User input Flag
  uint   Disposal:3;	// Disposal method
  uint   Reserved:3;	// Reserved
  ushort Delay;		// Delay time
  uchar  TColor;	// Transparent color index
  uchar  Terminator;	// = 0
} GCE;


//   ImageHeader:
struct {
  char	 Separator;	// ImageSeparator  = 0x2c
  ushort Left;		//  
  ushort Top;		// p 
  ushort Width;		// p
  ushort Height;	// 
  uint	 SizeLCT:3;	// 筮 GCT
  uint	 Reserved:2;	// ppp
  uint	 Sort:1;	// pp LCT p⭮
  uint	 Interlace:1;	// Interlased		( 0)
  uint	 LCT:1;		// LocalColorTable Flag (  0)
} ImageHeader;

//   pᮢ 
// p ⠪:
//
//  uchar  LZW Minimum Code Size;	// H砫쭮 ⢮ 
//  uchar  Data Sub block...		// 쪮  
//     稢 㫥 㡡

// H  ⮪   pp
//     0x3b

int GIFCompress (uchar *src, int srcsize, int bpp,
		  uchar *dst,
		  int	 palentry);

#define RED(pen) ((pen) >> 16) & 0xff
#define GREEN(pen) ((pen) >> 8) & 0xff
#define BLUE(pen) (pen) & 0xff

void GIFOutPut (uchar *bitmap, long x, long y, long *palette, int palentry, int Opt)
{
  FILE *GIFF;

  static char GIFPal [256 * 3];
  if  ((GIFF = fopen (OUTFILE, "wb")) == NULL) {
      perror (OUTFILE);
      return;
  }

  // pp㥬 
  strcpy (GIFHeader.GIFVer, "GIF89a");
  GIFHeader.Width   = x;
  GIFHeader.Height  = y;
  GIFHeader.GCT     = 1;
  GIFHeader.CRes    = 0;
  GIFHeader.Sort    = 0;
  GIFHeader.SizeGCT = 0;
  for (int SizeMask = 0xfe; palentry & SizeMask;
	  SizeMask <<= 1,
	  GIFHeader.SizeGCT++,
  	  GIFHeader.CRes++);

  GIFHeader.Backgr    = 0;
  GIFHeader.PixAspect = 0;

  fwrite (&GIFHeader, sizeof (GIFHeader), 1, GIFF);

  // 뢮 p

  char *PalCo = GIFPal;
  int	    i = 0;

  for (; i < palentry; i++) {
      *PalCo++ = RED   (palette[i]);
      *PalCo++ = GREEN (palette[i]);
      *PalCo++ = BLUE  (palette[i]);
  }

  for (; i < (1 << (GIFHeader.SizeGCT + 1)); i++)
      *PalCo++ = *PalCo++ = *PalCo++ = 0;

  fwrite (GIFPal, 3, 1 << (GIFHeader.SizeGCT + 1), GIFF);

  //  pp筮 p㭤     pp
  if (Opt & GOPT_TRANSPARENT) {
     GCE.Introducer = 0x21;	// 0x21
     GCE.Label      = 0xf9;		// 0xf9
     GCE.BSize      = 4;		// 4
     GCE.CFlag      = 1;	// Transparent color flag
     GCE.UIFlag     = 0;	// User input Flag
     GCE.Disposal   = 0;	// Disposal method
     GCE.Reserved   = 0;	// Reserved
     GCE.Delay      = 0;		// Delay time
     GCE.TColor     = 0;	// Transparent color index
     GCE.Terminator = 0;	// = 0

     fwrite (&GCE, sizeof (GCE), 1, GIFF);
  }
  // pp㥬 p pp

  ImageHeader.Separator = 0x2c;
  ImageHeader.Left	= 0;
  ImageHeader.Top	= 0;
  ImageHeader.Width	= x;
  ImageHeader.Height	= y;
  ImageHeader.LCT	= 0;
  if (Opt & GOPT_INTERLACED)
     ImageHeader.Interlace = 1;
  else
     ImageHeader.Interlace = 0;
  ImageHeader.Sort	= 0;
  ImageHeader.Reserved	= 0;
  ImageHeader.SizeLCT	= 0;

  fwrite (&ImageHeader, sizeof (ImageHeader), 1, GIFF);

  // p㥬  뢮 
  fputc (GIFHeader.SizeGCT + 1, GIFF);

  if (Opt & GOPT_INTERLACED) {
     uchar *IB = (uchar *)malloc (x * y);
     uchar *Ip = IB;
     int r;

     // p  p p
     for (r = 0; r < y; r += 8, Ip += x)
	 memcpy (Ip, bitmap + x * r, x);

     for (r = 4; r < y; r += 8, Ip += x)
	 memcpy (Ip, bitmap + x * r, x);

     for (r = 2; r < y; r += 4, Ip += x)
	 memcpy (Ip, bitmap + x * r, x);
     
     for (r = 1; r < y; r += 2, Ip += x)
	 memcpy (Ip, bitmap + x * r, x);
	
     memcpy (bitmap, IB, x * y);

     free (IB);
  }


  uchar *gifmap = (uchar *)malloc (x * y);
  int giflen = GIFCompress (bitmap, x * y, GIFHeader.SizeGCT + 1,
			    gifmap, palentry);

  fwrite (gifmap, giflen, 1, GIFF);

  free (gifmap);

  fputc (0x3b, GIFF);

  fclose (GIFF);
}

#define HSIZE 0x1000

#define XRFree	   -1

#define OutByte 					\
{                                                       \
  if ((CCount & 0xff) == 0) { /* p⪠ p  */\
     BlenPtr   = OutPtr;                                \
     *OutPtr++ = 0xff;                                  \
     CCount++;		/* H稭   */       \
  }                                                     \
  *OutPtr++ = OutStre & 0xff;                           \
  OutStre >>= 8;                                        \
  OutBits  -= 8;                                        \
  CCount++;                                             \
}

#define Output(val)		\
{                               \
  OutStre |= val << OutBits;    \
  OutBits += CBits;             \
  while (OutBits > 7)           \
        OutByte;                \
}

int GIFCompress (uchar *src, int srcsize, int bpp,
		  uchar *dst,
		  int	 palentry)
{
  int ClearCode = 1 << bpp;
  int EOICode	= ClearCode + 1;

  int FreeHash	= EOICode   + 1;	// p ᢮

  int CBits = bpp + 1;

//   室饣 ⮪
  ulong  OutStre = 0;
  int    OutBits = 0;
  uchar *OutPtr  = dst;

  uchar *BlenPtr = dst;

  int CCount = 0; 

  // ⢮ p⠭   src
  int PCount = 0;

  // 騩 ⮪ (楯窠)
  short  CStLen  = 0;
  int	 CCode	 = 0;	// pp ⮡  p㣠

  short **Hash;
  Hash = (short **)malloc (HSIZE * sizeof (short *));
  
  int i;

  // 樠p㥬 
  for (i = 0; i < HSIZE; i++) {
      Hash[i] = (short *)malloc (palentry * sizeof (short));
      memset (Hash[i], 0xff, palentry * sizeof (short));
  }

  Output (ClearCode);

  for (; PCount < srcsize; PCount++) {

      CStLen++;	// 塞 ᨬ  楯
      char c = src[PCount];

      if (CStLen == 1)			// p ᨬ  楯窥?
	 CCode = c;			// p ᨬ ᥣ !
      else
	 if ((Hash[CCode])[c] == XRFree) {
	    Output (CCode);
	    if (FreeHash == HSIZE) {	    // 襩  !
	       Output (ClearCode);
	       for (i = 0; i < HSIZE; i++)
      		   memset (Hash[i], 0xff, palentry * sizeof (short));
	       FreeHash = EOICode + 1;
	       CBits	= bpp + 1;
	       CStLen	= 1;
	       CCode	= c;
	       continue;
	    }

	    // 塞  
	    (Hash[CCode])[c] = FreeHash;
	    if ((FreeHash++) > ((1 << CBits) - 1))
	       CBits++;
	    CStLen = 1;
	    CCode  = c; 
	 } else
	    CCode = (Hash[CCode])[c];
  }

  Output (CCode);
  Output (EOICode);

  if (OutBits > 0) {
     *OutPtr++ = OutStre & 0xff;	//  ⠢訩 
     CCount++;
  }

  *BlenPtr = (CCount - 1) & 0xff; // ppp㥬  ⠢襣 

  *OutPtr++ = 0x00;	// p襭 
  CCount++;

  // 樠p㥬 
  for (i = 0; i < HSIZE; free (Hash[i++]));
  free (Hash);

  return CCount;
}
